/**
 * description
 *
 * @author eson
 *2022年7月20日-10:00:05
 */
package com.yuandian.dataflow.statemachine.state;

 
import com.alibaba.nacos.shaded.io.grpc.netty.shaded.io.netty.handler.codec.http.HttpContentEncoder.Result;
import com.alipay.sofa.jraft.error.RemotingException;
import com.google.protobuf.Any;
import com.yuandian.dataflow.controller.PacketsProcessor.PacketsRequest;
import com.yuandian.dataflow.proto.msgtype.BacktrackingFlowOuterClass;
import com.yuandian.dataflow.statemachine.StateServerFactory;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import lombok.var;
import lombok.extern.slf4j.Slf4j;

/**
 * description
 *
 * @author eson
 *         2022年7月20日-10:00:05
 */
@Slf4j
@Getter
@Setter
@ToString
public class StateFactory {

    public static Thread masterExecute = new Thread(new Runnable() {
        @Override
        public void run() {
            try {
                while (true) {
                    log.debug("master execute {}", StateServerFactory.getServerId());
                    var alivePeers = StateServerFactory.getCluster().getRaftNode().listAlivePeers();
                    log.debug("master execute {}", StateServerFactory.getCluster().getRaftNode().listAlivePeers());
                    if (alivePeers != null) {
                        var ss = StateServerFactory.getStateServer();
                        StateServerFactory.getStateServer().useFsmStateAsync((state) -> {
                            synchronized(alivePeers){
                            alivePeers.forEach((peer) -> {
                                var ws = state.getWorkers().get(peer);
                                if (ws != null) {
                                    var cap = 100 - ws.getTaskQueueSize();
                                    if (cap > 0) {
                                        log.debug("{}", cap);
                                        var request = new PacketsRequest();
                                        for(int i = 0; i < cap ; i++ ) {
                                            var p = Any.pack(
                                                BacktrackingFlowOuterClass.BacktrackingFlow.newBuilder()
                                                        .setTableId(10086)
                                                        .build()
                                                );

                                                request.getPackets().add(p);

                                        }
                          
                                        try {
                                            var result = ss.getRpcClient().invokeSync(ws.getPeerId().getEndpoint(), request, 5000);
                                            log.info("{}", result);
                                        } catch (InterruptedException e) {
                                            // TODO Auto-generated catch block
                                            e.printStackTrace();
                                        } catch (RemotingException e) {
                                            // TODO Auto-generated catch block
                                            e.printStackTrace();
                                        }
                                    }
                                }
                                alivePeers.notifyAll(); 
                            });
                        }
                            
                            return null;
                        });
                        synchronized(alivePeers){
                            alivePeers.wait(5000);
                        }
                        
                    }

                    Thread.sleep(2000);
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        }
    });

    public static Thread getMasterExecute() {
        return masterExecute;
    }

    public static void Init() {

    }

}
